-- Throttle
--
-- Version 2.0
-- Autor Ralf08
-- 
-- Change log:
-- 10.01.2016 / Ralf08 / Release
-- 06.11.2017 / Ralf08 / new on/off function; MP added / FS17



--local FirstRun
Throttle = {};

local throttle_directory = g_currentModDirectory;
Throttle.enable = false


function Throttle:load()
	
	self.throttle = {};
    self.throttle.changeDelay = 250;
    self.throttle.changeCurrentDelay = 0;
    self.throttle.speedSent = self.throttle.speed;
	self.throttle.vgetold = 0
	self.throttle.elide = true
			
	if self.cruiseControl.maxSpeed > 20 then
		self.throttle.vreduced = 20
	else
		self.throttle.vreduced = self.cruiseControl.maxSpeed
	end;
	self.throttle.vset = self.cruiseControl.maxSpeed
	
	
end;

function Throttle:delete()
end;

function Throttle:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Throttle:keyEvent(unicode, sym, modifier, isDown)
end;


function Throttle:update(dt)
	if self.isEntered and self.isClient and not self.isHired then
        -- do all the input handling
		if self:getIsActiveForInput(false) and self.cruiseControl.isActive then
			-- throttle on/off
			if InputBinding.hasEvent(InputBinding.THROTTLE_TOGGLE) then
				Throttle.enable = not Throttle.enable
			end;
			if Throttle.enable then
				-- change modus
				if InputBinding.hasEvent(InputBinding.THROTTLE_MODUS) then
					if self.throttle.vset == self.cruiseControl.maxSpeed then
						self.throttle.vset = self.throttle.vreduced
					else
						self.throttle.vset = self.cruiseControl.maxSpeed
					end;
				end;
				-- Cruise Control
				local inputW = InputBinding.getAnalogInputAxis(InputBinding.THROTTLE_AXIS)
				if inputW == 0 and self.throttle.elide then -- problem on farm silo elide
					self.throttle.elide = false
				else
					self.throttle.vget = math.floor((self.throttle.vset) / 1.8 * (inputW + 0.9))
					if self.throttle.vget <= 0 then
						self.throttle.vget = 0
						if self.cruiseControl.speed == 1 and self:getLastSpeed() < 2 then
							self:setCruiseControlState(Drivable.CRUISECONTROL_STATE_OFF)
						end;
					elseif self.throttle.vget >= self.cruiseControl.maxSpeed then
						self.throttle.vget = self.cruiseControl.maxSpeed
					end;
					if self.throttle.vget ~= self.cruiseControl.speed and not (self.throttle.vget == 0 and self.cruiseControl.speed == 1) then
						self.throttle.changeCurrentDelay = self.throttle.changeCurrentDelay - dt*4;
						if self.throttle.changeCurrentDelay < 0 then
							self.throttle.setspeed = self.cruiseControl.speed
							if self.throttle.vget > self.cruiseControl.speed then
								self.throttle.setspeed = self.throttle.vget
							elseif self.throttle.vget < self.cruiseControl.speed and self.cruiseControl.speed > 1 then
								if self:getLastSpeed() - self.cruiseControl.speed < -10 then
									if self:getLastSpeed() < self.throttle.vget then
										self.throttle.setspeed = self.throttle.vget
									else
										self.throttle.setspeed = self:getLastSpeed() - 1
									end;									
								else
									self.throttle.setspeed = self.cruiseControl.speed - 1
								end;
							end;
							if self.cruiseControl.state == Drivable.CRUISECONTROL_STATE_OFF and self.throttle.vgetold ~= self.throttle.vget then
								self:setCruiseControlState(Drivable.CRUISECONTROL_STATE_ACTIVE);
							end;
							self.throttle.wasSpeedChanged = true;
							self:setCruiseControlMaxSpeed(self.throttle.setspeed);
							self.throttle.changeCurrentDelay = self.throttle.changeDelay;
						end;
						self.throttle.vgetold = self.throttle.vget
					else
						self.throttle.wasSpeedChanged = false;
						self.throttle.changeCurrentDelay = 0;
					end;
					self.throttle.elide = true
				end;
				
				if not self.throttle.wasSpeedChanged and self.cruiseControl.speed ~= self.throttle.speedSent then
					if g_server ~= nil then
						g_server:broadcastEvent(SetCruiseControlSpeedEvent:new(self, self.cruiseControl.speed), nil, nil, self);
					else
						g_client:getServerConnection():sendEvent(SetCruiseControlSpeedEvent:new(self, self.cruiseControl.speed));
					end;
					self.throttle.speedSent = self.cruiseControl.speed;
				end;
			end;
		end;
	end;
end;

function Throttle:updateTick(dt)
end;

function Throttle:readStream(streamId, connection)
end;

function Throttle:writeStream(streamId, connection)
end;


function Throttle:onEnter()
end;

function Throttle:onLeave()
end;

function Throttle:draw()
end;
