-- Throttle
--
-- Version 2.0
-- Autor Ralf08
-- 
-- Change log:
-- 10.01.2016 / Ralf08 / release
-- 06.11.2017 / Ralf08 / new on/off function; MP added / FS17


Throttle_Register = {};

if SpecializationUtil.specializations["Throttle"] == nil then
	SpecializationUtil.registerSpecialization("Throttle", "Throttle", g_currentModDirectory.."Throttle.lua")
	Throttle_Register.isLoaded = false;
end;


function Throttle_Register:loadMap(name)
	if self.firstRun == nil then
		self.firstRun = false;
		for k, v in pairs(VehicleTypeUtil.vehicleTypes) do
			if v ~= nil then
				local allowInsertion = true;
				for i = 1, table.maxn(v.specializations) do
					local vs = v.specializations[i];
					if vs ~= nil and vs == SpecializationUtil.getSpecialization("drivable")then
						local v_name_string = v.name 
						local point_location = string.find(v_name_string, ".", nil, true)
						if point_location ~= nil then
							local _name = string.sub(v_name_string, 1, point_location-1);
							if rawget(SpecializationUtil.specializations, string.format("%s.Throttle", _name)) ~= nil then
								allowInsertion = false;								
							end;							
						end;
						if allowInsertion then	
							table.insert(v.specializations, SpecializationUtil.getSpecialization("Throttle"));
						end;
					end;
				end;
			end;	
		end;
		g_i18n.globalI18N.texts["throttle_axis"] = g_i18n:getText("throttle_axis");
		g_i18n.globalI18N.texts["throttle_toggle"] = g_i18n:getText("throttle_toggle");
		g_i18n.globalI18N.texts["throttle_modus"] = g_i18n:getText("throttle_modus");
	end;	
end;


function Throttle_Register:deleteMap()
  
end;

function Throttle_Register:keyEvent(unicode, sym, modifier, isDown)

end;

function Throttle_Register:mouseEvent(posX, posY, isDown, isUp, button)

end;

function Throttle_Register:update(dt)
	
end;

function Throttle_Register:draw()
end;

addModEventListener(Throttle_Register);